#include <stdio.h>
#include "mlvalues.h"
#include "callback.h"
#include "common.h"
#include "fail.h"

extern char **main_argv;
value mixte_byte_start(value unit) /* ML */
{
  byte_caml_main(main_argv);
  return Val_unit;
}

value c_import_module(value name) /* ML */
{
  value *res;
  
  res = caml_named_value(String_val(name));
  if(res == NULL)
    failwith("Module not registered");
  else
    return *res;
}



/* We claim these constants are big so that e.g. the Mips compiler
   will not assume that they are in the .sdata section */

typedef char caml_generated_constant[256];
extern caml_generated_constant Out_of_memory, Sys_error, Failure,
  Invalid_argument, End_of_file, Division_by_zero, Not_found, 
  Match_failure;

/* les exceptions doivent etre definies statiquement (pour le code natif)
et dynamiquement pour le bytecode.
*/
void mixte_init(void)
{
  if(with_native){
    Assign(Field(global_data, FAILURE_EXN), (value)Failure);
    Assign(Field(global_data, OUT_OF_MEMORY_EXN), (value)Out_of_memory);
    Assign(Field(global_data, SYS_ERROR_EXN), (value)Sys_error);
    Assign(Field(global_data, END_OF_FILE_EXN), (value)End_of_file);
    Assign(Field(global_data, ZERO_DIVIDE_EXN), (value)Division_by_zero);
    Assign(Field(global_data, NOT_FOUND_EXN),  (value)Not_found);
  }
}

value native_closure = Val_unit;
value native_caller1 = Val_unit;
value native_caller2 = Val_unit;
value native_caller3 = Val_unit;
extern value exception_traps;

value register_asm(value caller1,value caller2,value caller3,value wrapper)
{
  native_closure = wrapper;
  register_global_root(&native_closure);
  native_caller1 = caller1;
  register_global_root(&native_caller1);
  native_caller2 = caller2;
  register_global_root(&native_caller2);
  native_caller3 = caller3;
  register_global_root(&native_caller3);
  return Val_unit;
}

value byte_raise_exn(value exc_traps,value exn)
{
  exception_traps = exc_traps;
  mlraise(exn);
}
