(***********************************************************************)
(*                                                                     *)
(*                     the JoCaml language                             *)
(*                                                                     *)
(*                 Luc MARANGET and Fabrice LE FESSANT,                *)
(*                    projet PARA, INRIA Rocquencourt                  *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

let header = "$Id: parse_opts.ml,v 1.1 1999/09/30 13:21:54 lefessan Exp $" 
let verbose = ref 0
and readverb = ref 0
;;
let silent = ref false
;;

let files = ref ([]: string list)
;;

let add_input s =
  files := s :: !files
;;

type language = Francais | English
;;

let language = ref English
and symbols = ref true
;;

let read_idx = ref false
;;

let except = ref ([]: string list)
;;

let path = ref ([]:string list)
;;

let outname = ref ""
;;

let _ = 
  Genserver.ns_name := "hevea_server";
  Arg.parse 
    ((Genserver.ns_args ()) @
     [
     ("-v", Arg.Unit (fun () -> readverb := !readverb + 1),
      ", verbose flag, can be repeated to increase verbosity") ;
     ("-s", Arg.Unit (fun () -> silent := true),
      ", suppress warnings") ;
     ("-e", Arg.String (fun s -> except := s :: !except),
      "filename, prevent file ``filename'' from being read") ;
     ("-idx",Arg.Unit (fun () -> read_idx := true),
      ", attempt to read .idx file (useful if indexing is non-standard)") ;
     ("-francais",Arg.Unit (fun () -> language := Francais),
      ", french mode") ;
     ("-nosymb",Arg.Unit (fun () -> symbols := false),
      ", do not output symbol fonts") ;
     ("-I", Arg.String (fun s -> path := s :: !path),
      "dir, add directory ``dir'' to search path") ;
     ("-o", Arg.String (fun s -> outname := s),
      "filename, make hevea output go into file ``filename''");
   ])
    (fun s -> ())
    ("hevea "^Version.version)
;;
