(***********************************************************************)
(*                                                                     *)
(*                     the JoCaml language                             *)
(*                                                                     *)
(*   Fabrice LE FESSANT, projet PARA, INRIA Rocquencourt               *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* ----------------------------------------------------   HEVEA stuff *)


(* To avoid passing channels on the network:
   Should use another technique, such as a stub for channels ...
*)

let _ =  Image.buff := Out.Null

let start_hevea  (args: string list) = 
  
(* initialize all HeVea structures *)
  List.iter (fun s -> Parse_opts.add_input s) args;

  Image.buff := (Out.create_chan (open_out "/dev/null"));
  Location.curlexbuf := Lexing.from_string "";

(* start HeVea *)
  try
    Latexmain.main (); 
    kill top_location
  with x -> 
    prerr_string "Ending Exception:";
    prerr_endline (Printexc.to_string x);
    Location.print_pos () ;
    prerr_endline "Adios" ;
    kill top_location
;;

(* --------------------------------------------------    server stuff *)

let def arrived! () | wait_go () = reply
and register_me (location,hostname,args) =
  { wait_go (); reply } |
  loc hevea_agent [Version; Parse_opts; Mylib; Files; Myfiles; Location; Out; Counter; Symb; Image; Subst; Save;  Aux; Latexmacros;  Html; Section; Foot; Entry; Index; Latexscan; Latexmain] do
    { go location; {| arrived () }; start_hevea args; }

let _ = Genserver.server register_me vartype
