(***********************************************************************)
(*                                                                     *)
(*                           xlib for Ocaml                            *)
(*                                                                     *)
(*       Fabrice Le Fessant, projet Para/SOR, INRIA Rocquencourt       *)
(*                                                                     *)
(*  Copyright 1998 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Xtypes


let anyButton = 0
let copyVisualFromParent = 0
let noPixmap = 0
let pixmapParentRelative = 1
let copyPixmapFromParent = 0
let copyColormapFromParent = 0
let noCursor = 0
let copyDepthFromParent = 0
let unmapGravity = ForgetGravity
let noOwner = 0
let noConfineTo = 0
let anyKey = 0
let pointerRoot = 1
let noFocus = 0
let anyModifier = 1 lsl 15
let shiftMask = 1
let lockMask = 2
let controlMask = 4
let mod1Mask = 8
let mod2Mask = 16
let mod3Mask = 32
let mod4Mask = 64
let mod5Mask = 128
let button1Mask = 256
let button2Mask = 512
let button3Mask = 1024
let button4Mask = 2048
let button5Mask = 4096

let none = 0
let parentRelative = 1
let copyFromParent = 0
let pointerWindow = 0
let inputFocus = 1
let anyPropertyType = 0
let anyButton = 0
let allTemporary = 0
let currentTime = 0
let noSymbol = 0
let xerrors =
    [|
    " Success";
    "BadRequest";
    "BadValue";
    "BadWindow";
    "BadPixmap";
    "BadAtom";
    "BadCursor";
    "BadFont";
    "BadMatch";
    "BadDrawable";
    "BadAccess";
    "BadAlloc";
    "BadColor";
    "BadGC";
    "BadIDChoice";
    "BadName";
    "BadLength";
    "BadImplementation"|]

let xopcodes =
[| "UnusedOpcode";
  "CreateWindow";
  "ChangeWindowAttributes";
  "GetWindowAttributes";
  "DestroyWindow";
  "DestroySubwindows";
  "ChangeSaveSet";
  "ReparentWindow";
  "MapWindow";
  "MapSubwindows";
  "UnmapWindow";
  "UnmapSubwindows";
  "ConfigureWindow";
  "CirculateWindow";
  "GetGeometry";
  "QueryTree";
  "InternAtom";
  "GetAtomName";
  "ChangeProperty";
  "DeleteProperty";
  "GetProperty";
  "ListProperties";
  "SetSelectionOwner";
  "GetSelectionOwner";
  "ConvertSelection";
  "SendEvent";
  "GrabPointer";
  "UngrabPointer";
  "GrabButton";
  "UngrabButton";
  "ChangeActivePointerGrab";
  "GrabKeyboard";
  "UngrabKeyboard";
  "GrabKey";
  "UngrabKey";
  "AllowEvents";
  "GrabServer";
  "UngrabServer";
  "QueryPointer";
  "GetMotionEvents";
  "TranslateCoordinates";
  "WarpPointer";
  "SetInputFocus";
  "GetInputFocus";
  "QueryKeymap";
  "OpenFont";
  "CloseFont";
  "QueryFont";
  "QueryTextExtents";
  "ListFonts";
  "ListFontsWithInfo";
  "SetFontPath";
  "GetFontPath";
  "CreatePixmap";
  "FreePixmap";
  "CreateGC";
  "ChangeGC";
  "CopyGC";
  "SetDashes";
  "SetClipRectangles";
  "FreeGC";
  "ClearArea";
  "CopyArea";
  "CopyPlane";
  "PolyPoint";
  "PolyLine";
  "PolySegment";
  "PolyRectangle";
  "PolyArc";
  "FillPoly";
  "PolyFillRectangle";
  "PolyFillArc";
  "PutImage";
  "GetImage";
  "PolyText8";
  "PolyText16";
  "ImageText8";
  "ImageText16";
  "CreateColormap";
  "FreeColormap";
  "CopyColormapAndFree";
  "InstallColormap";
  "UninstallColormap";
  "ListInstalledColormaps";
  "AllocColor";
  "AllocNamedColor";
  "AllocColorCells";
  "AllocColorPlanes";
  "FreeColors";
  "StoreColors";
  "StoreNamedColor";
  "QueryColors";
  "LookupColor";
  "CreateCursor";
  "CreateGlyphCursor";
  "FreeCursor";
  "RecolorCursor";
  "QueryBestSize";
  "QueryExtension";
  "ListExtensions";
  "ChangeKeyboardMapping";
  "GetKeyboardMapping";
  "ChangeKeyboardControl";
  "GetKeyboardControl";
  "Bell";
  "ChangePointerControl";
  "GetPointerControl";
  "SetScreenSaver";
  "GetScreenSaver";
  "ChangeHosts";
  "ListHosts";
  "SetAccessControl";
  "SetCloseDownMode";
  "KillClient";
  "RotateProperties";
  "ForceScreenSaver";
  "SetPointerMapping";
  "GetPointerMapping";
  "SetModifierMapping";
  "GetModifierMapping";
  "NoOperation"|]
