/***********************************************************************/
/*                                                                     */
/*                           NPRremote                                 */
/*                                                                     */
/*          Francois Rouaix, projet Cristal, INRIA Rocquencourt        */
/*                                                                     */
/*  Copyright 1996 Institut National de Recherche en Informatique et   */
/*  Automatique.  Distributed only by permission.                      */
/*                                                                     */
/***********************************************************************/

/*
 * Simple Netscape Navigator 3.0 Plugin for remote-server.
 In the following : Server refers to a given "plugin server", NN to
                    Netscape Navigator.

 A single Server program is run (once) at initialisation time with
 arguments -pid npid (or whatever command line you want that includes
 npid information), where npid is the PID of NN.
 [npid] is used to create a named pipe MEET where Server and Netscape
 can meet.

   Startup:
    NN connects to Server twice :
      - the master socket MSock, to drive creation of instances
      - the slave socket CSock, to accept stream requests from the server
      When first needed, we add an XtAddInput handler on CSock

   Instance Creation:
    NPP_New writes on MSock a request for creating an instance (including
        arguments of NPP_New). The Server responds with an Instance ID.

    NPP_Destroy writes on MSock a request for instance destruction (with
        a given Instance ID)

   Streams:
    NPP_NewStream opens a new connection on MEET
      the file descriptor is stored in pdata of the NPStream
      NPP_WriteReady does a select() with zero timeout on
      the fd, and returns BUFSIZE ?
      NPP_Write writes on the fd
      NPP DestroyStream closes the fd

    NPP_URLNotify: writes on NC ?

Netscape callbacks made available to the client:

    NPN_NewStream, as available in the application:
     * writes on the CN pipe
     * the CN handler connects to the C port, opens a 
       stream, and starts a new handler on this stream
       the handler does NPN_Write when data is available,
       and NPN_DestroyStream when the stream is closed
       (and removes itself as well)

    NPN_GetUrl : writes on the CN pipe
      (target NULL: NPP will be called again)
    NPN_GetURLNotify:
*/

/* These are the specific data of the plugin. shell.c can remain untouched */

/* A generic name defining the system */
#define NPRem_What "Joplug: Un plugins pour les fenetres graphiques de JoCaml"
/* The server command */
#define NPRem_Command "Jopluge -pid %d > /dev/null"
/* Returned by NPP_GetMimeDescription */
#define NPRem_MIME "application/x-JoCaml-applet::JoCaml Applet"
/* Returned by NPP_GetValue */
#define NPRem_Name "JoCaml Applet Viewer 0.1"
#define NPRem_Desc "This plugin handles JoCaml Applets"
/* Definition of AF_UNIX socket : $HOME/.netscape/calves-pid */
#define NPRem_Socket "%s/.netscape/Joplug-%08d"

/* end of configuration section */

extern int readint(int);
extern char *readstring(int);
extern void writeint(int,int);
extern void writestring(int, const char*, int);
