(***********************************************************************)
(*                                                                     *)
(*                           Objective Caml                            *)
(*                                                                     *)
(*            Xavier Leroy, projet Cristal, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1996 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

(* $Id: std_exit.ml,v 1.1 1999/09/30 13:26:25 lefessan Exp $ *)

external print_stats: unit -> unit = "print_stats"

let _ =
(* Ensure that all threads have exited *)
  Thread.suspend_on_terminaison (!Go.threads + !Space.threads + !Dgc.threads);
(* Ensure that [at_exit] functions are called at the end of every program *)
  Debug.f 'S' print_stats;
  do_at_exit ()
