
value trigger_def (value params)
{
  value def = Field(params,0); /* BLOCK */
  value ord_v = Field(params,1);
  value arg = Field(params,2);  /* BLOCK */
  value ldef = Field(def,STUB_LOCAL); /* BLOCK */
  value ord = Int_val(ord_v);
  value index = ord & 127;
  value dispatch = ord >> 10;
  value structure = Field(ldef,1);   /* BLOCK */
  value nmult = Int_val(Field(structure,0));
  value state = Field(ldef,0);
  value bit = 1 << (index + 1);
  value cons;

  Good_stub("trigger_def",def);

  if(! (state & bit)){    /* premier message */
    value tests = Field(structure,2+index); /* BLOCK */
    value ntests =   Wosize_val(tests);
    value new_state = state | bit;
    value inverse = ~new_state;
    value nchans = Int_val(Field(structure,1)); 
    value i;
    value processes = Field(ldef,2);   /* BLOCK */

    for(i=0;i<ntests;i+=2){
      if(!(Field(tests,i) & inverse)){
      /* we must trigger this process */
	/* first we have to construct its args */
	value match = Field(tests,i+1);
	value nargs;
	value process;
	value thread_num;

	/* un test de trop: ca peut etre fait definitivement au premier 
	   fill_automata */
	if(Is_long(match)){
	  match = Field(structure,2+nchans+Int_val(match));
	  Assign(Field(tests,i+1),match);
	}
	nargs = Wosize_val(match)-1;
	process = Field(match,0);
	
	if(nargs==1){ /* un seul argument, c'est le message ! */
	  if(index < nmult) /* dispatch */
	    process = Field(process,dispatch);

	  thread_num = Int_val(Field(process,1));
	  process = Int_val(Field(process,0));
	  if (!thread_num){
	    gen_thread_new(Field(def,STUB_POS),
			   Field(processes,process),
			   Val_true,arg);
	  } else 
            if(thread_num!=-1){
              reuse_thread_loc(Field(def,STUB_POS),
                               Field(processes,process),
                               arg,Field(arg,0));
            } else {
              local_thread_reuse(Field(def,STUB_POS),
                                 Field(processes,process),
                                 arg,curr_thread);
            }
          return Val_unit;
	} else {
	  value args;
	  value chan;
	  value list;

	  Begin_roots5(match,processes,process,arg,ldef);
	  args = alloc(nargs,0);
	  End_roots();
	  for(i=0;i<nargs;i++){
	    chan = Int_val(Field(match,i+1));
	    if(chan==index){ /* message actuel */
	      if(index<nmult) /* dispatch */
		process = Field(process,dispatch);
	      Assign(Field(args,i),arg);
	    } else {
              /* message queue:
              <proc;msg>
              */
              if(Is_long(Field(ldef,3+chan*2))){
                /* message non alloue */
                if(chan<nmult) /* dispatch */
                  process = Field(process, Int_val(Field(ldef,3+chan*2)));
                Assign(Field(args,i),Field(ldef,4+chan*2));
                state &= ~(1 << (chan+1));
              } else {
                /* messages alloues */
                list = Field(ldef,3+2*chan);
                if(chan<nmult) /* dispatch */
                  process = Field(process, Int_val(Field(list,2)));
                Assign(Field(args,i),Field(list,0));
                list = Field(list,1);
                if(list == Val_unit)
                  state &= ~(1 << (chan+1));
                else
                  Assign(Field(ldef,3+2*chan),list);
              }
            }
          }
	  Field(ldef,0) = state;
	  thread_num = Int_val(Field(process,1));
	  process = Int_val(Field(process,0));
	  if (!thread_num){
	    gen_thread_new(Field(def,STUB_POS),
			   Field(processes,process),
			   Val_true,args);
	  } else
            if(thread_num != -1) {
              value thread_stub = Field(Field(args,thread_num-1),0);
              reuse_thread_loc(Field(def,STUB_POS),
                               Field(processes,process),
                               args,
                               thread_stub);
            } else {
              local_thread_reuse(Field(def,STUB_POS),
                                 Field(processes,process),
                                 args,curr_thread);
            }
	  return Val_unit;
	}
      }
    }
    /* premier message: on ne l'alloue pas */
    Field(ldef,0) = new_state;
    Assign(Field(ldef,3+2*index),Val_int(dispatch));
    Assign(Field(ldef,4+2*index),arg);
  } else {
    /* pas le premier message de ce type */
    Begin_roots2(ldef,arg); /* ldef, arg */
    def = Field(ldef,3+2*index);
    if(Is_long(Field(ldef,3+2*index))){
      /* second message: on alloue d'abord le  premier */
      cons = alloc(3,0);
      Field(cons,0) = Field(ldef,4+2*index);
      Field(cons,1) = Val_unit;
      Field(cons,2) = def;
      Assign(Field(ldef,3+2*index),cons);
      def = cons;
    }
    if(index < nmult){
      cons = alloc(3,0);
      Field(cons,2) = Val_int(dispatch);
    } else
      cons = alloc(2,0);
    Field(cons,0) = arg;
    Field(cons,1) = def;
    Assign(Field(ldef,3+2*index),cons);
    End_roots();
  }
  
  return Val_unit;
}
