open Obj

external register_named_value: string -> t -> unit = "register_named_value"


let export_module module_name m =
  register_named_value ("module+"^module_name) m;

external asm_callbyte: ('a -> 'b) -> 'a -> 'b = "asm_callbyte"
external byte_raise_exn: int -> exn -> 'a = "byte_raise_exn"

let native_caller1 f x exception_traps =
  if exception_traps>0 then
    try
      f x
    with
      e -> byte_raise_exn exception_traps e
  else
    f x

let native_caller2 f (x,y) exception_traps =
  if exception_traps>0 then
    try
      f x y
    with
      e -> byte_raise_exn exception_traps e
  else
    f x y

let native_caller3 f (x,y,z) exception_traps =
  if exception_traps>0 then
    try
      f x y z
    with
      e -> byte_raise_exn exception_traps e
  else
    f x y z

let native_closure f x = asm_callbyte f x

(* tests.. *)
let f x = ("toto"^x^"tata")

let boxed_closure = repr (native_closure f)

let size = size boxed_closure
let _ = Debug.print1 'c' "size : %d\n" size
let _ = 
  for i=0 to size - 1 do
    if (field boxed_closure i) == (repr f) then Debug.print1 'c' "pos %d\n" i
  done

external asm_register : t -> t -> t -> t -> unit = "register_asm"

let _  =
  asm_register (repr native_caller1) (repr native_caller2) 
    (repr native_caller3) boxed_closure
